Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/ssao.cg
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/ssao.cg	(revision 3364)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/ssao.cg	(revision 3365)
@@ -547,7 +547,7 @@
 		// they possibly have any influence on the ao
 
-		if (1)//cosAngle > 0)
-		{
-			float pixelValid = sampleColor.x;
+		if (cosAngle >= 0)
+		{
+			float pixelValid = 0;//sampleColor.x;
 
 			if (1)//pixelValid < 0.5f)
@@ -555,5 +555,5 @@
 				const float3 sampleDiffVec = tex2Dlod(attribsTex, float4(texcoord, .0f, .0f)).xyz;
 				//pixelValid = max(pixelValid, length(sampleDiffVec - diffVec) < 5e-3f ? .0f : 100.0f);
-				//pixelValid = max(pixelValid, length(sampleDiffVec - diffVec) < 5e-3f ? .0f : 4.0f);
+				pixelValid = max(pixelValid, length(sampleDiffVec - diffVec) < 5e-3f ? .0f : 4.0f);
 				//pixelValid = length(sampleDiffVec - diffVec) < 1e-3f ? .0f : 10.0f;
 			}
@@ -686,7 +686,7 @@
 #else
 
-	const float3 diffVec = float3(.0f);
+	const float3 diffVec      = float3(.0f);
 	const bool isMovingObject = false;
-	const float oldSsao = .0f;
+	const float oldSsao       = .0f;
 	
 	float oldWeight = .0f;
@@ -754,6 +754,6 @@
 			const float factor = 4.0f;
 			//if (oldIdx >= factor * newWeight) oldIdx = 0;
-			oldWeight = min(oldWeight, factor * newWeight);
-			//oldWeight = oldIdx = .0f; 
+			//oldWeight = min(oldWeight, factor * newWeight);
+			oldWeight = oldIdx = .0f; 
 		}
 	}
@@ -771,5 +771,5 @@
 	const float combinedWeight = clamp(newWeight + oldWeight, .0f, temporalCoherence);
 
-	OUT.illum_col.y = ao.y;//combinedWeight;
+	OUT.illum_col.y = combinedWeight;
 	OUT.illum_col.z = oldIdx + newWeight; // the new index
 	OUT.illum_col.w = eyeSpaceDepth;
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/combineSsaoSep.cg
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/combineSsaoSep.cg	(revision 3364)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/combineSsaoSep.cg	(revision 3365)
@@ -275,6 +275,7 @@
 	//OUT.illum_col.xyz = float3(ao.w * 5e-1f, 0, 0);
 	//OUT.illum_col.xyz = float3(ao.z * 1e-3f);
-	//OUT.illum_col.xyz = float3(ao.y * 1e-3f);
-	OUT.illum_col.xyz = float3(ao.y);
+	
+	//OUT.illum_col.xyz = float3(ao.y * 5e-4f);
+	//OUT.illum_col.xyz = float3(ao.y);
 	//OUT.illum_col.xyz = ao.xyz;
 
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/deferred.cg
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/deferred.cg	(revision 3364)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/deferred.cg	(revision 3365)
@@ -312,5 +312,5 @@
 			  (oldEyeSpaceDepth < DEPTH_THRESHOLD) && (projectedEyeSpaceDepth < DEPTH_THRESHOLD) &&
 			  //(oldDynamic || newDynamic) &&  // check if we have a dynamic object 
-			  (depthDif > 5e-3f)))//MIN_DEPTH_DIFF)))
+			  (depthDif > 5e-2f)))//MIN_DEPTH_DIFF)))
 			  ) // and there is a depth discontinuity
 	{	
@@ -322,5 +322,5 @@
 	}
 	
-	isPixelValid = depthDif;
+	//isPixelValid = depthDif;
 
 	return float2(isPixelValid, abs(oldEyeSpaceDepth - projectedEyeSpaceDepth));
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp	(revision 3362)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp	(revision 3365)
@@ -828,5 +828,5 @@
 	//fbo->AddColorBuffer(ColorBufferObject::RGB_UBYTE, ColorBufferObject::WRAP_CLAMP_TO_EDGE, ColorBufferObject::FILTER_NEAREST);
 	// buffer holding the difference vector to the old frame
-	fbo->AddColorBuffer(ColorBufferObject::RGB_FLOAT_16, ColorBufferObject::WRAP_CLAMP_TO_EDGE, ColorBufferObject::FILTER_LINEAR);
+	fbo->AddColorBuffer(ColorBufferObject::RGB_FLOAT_32, ColorBufferObject::WRAP_CLAMP_TO_EDGE, ColorBufferObject::FILTER_LINEAR);
 	//fbo->AddColorBuffer(ColorBufferObject::RGB_UBYTE, ColorBufferObject::WRAP_CLAMP_TO_EDGE, ColorBufferObject::FILTER_LINEAR);
 	// another color buffer
@@ -1208,6 +1208,6 @@
 
 		//const float rotAngle = M_PI * 1e-3f;
-		//const float rotAngle = 0.3f * M_PI / 180.0f;
-		const float rotAngle = 0.6f * M_PI / 180.0f;
+		const float rotAngle = 1.5f * M_PI / 180.0f;
+		//const float rotAngle = 0.6f * M_PI / 180.0f;
 
 		Matrix4x4 rotMatrix = RotationZMatrix(rotAngle);
@@ -1221,5 +1221,5 @@
 
 		//const float moveSpeed = 5e-3f;
-		const float moveSpeed = 1e-1f;
+		const float moveSpeed = 5e-1f;
 		motionPath->Move(moveSpeed);
 	}